### Home Classes Methods

### In Files

- lib/amqp/int_allocator.rb

### Parent

Object

### Methods

- ::new
- #allocate
- #allocated?
- #find_unallocated_position
- #free
- #release
- #reset

### Class/Module Index

Quicksearch

- AMQP
- AMQP::BitSet
- AMQP::BlankSlate
- AMQP::Broker
- AMQP::Channel
- AMQP::ChannelClosedError
- AMQP::Client
- AMQP::Consumer
- AMQP::Error
- AMQP::Exchange
- AMQP::Header
- AMQP::IncompatibleOptionsError
- AMQP::IntAllocator
- AMQP::Integration
- AMQP::Integration::Rails
- AMQP::Logger
- AMQP::PossibleAuthenticationFailureError
- AMQP::Queue
- AMQP::RPC
- AMQP::RPC::Client
- AMQP::RPC::Server
- AMQP::Session
- AMQP::TCPConnectionFailed
- AMQP::Utilities
- AMQP::Utilities::EventLoopHelper
- AMQP::Utilities::ServerType
- MQ
- MQ::Exchange
- MQ::Logger
- MQ::Queue
- EM
- Object

No matching classes.

# AMQP::IntAllocator

Simple bitset-based integer allocator, heavily inspired by com.rabbitmq.utility.IntAllocator class in the RabbitMQ Java client.

Unlike monotonically incrementing identifier, this allocator is suitable for very long running programs that aggressively allocate and release channels.

### Attributes

hi[R]

@return [Integer] Upper boundary of the integer range available for allocation

lo[R]

@return [Integer] Lower boundary of the integer range available for allocation

number_of_bits[R]

@return [Integer] Number of integers in the allocation range

### Public Class Methods

new(lo, hi) click to toggle source

@param [Integer] lo Lower boundary of the integer range available for allocation @param [Integer] hi Upper boundary of the integer range available for allocation @raise [ArgumentError] if upper boundary is not greater than the lower one

    # File lib/amqp/int_allocator.rb, line 26
    def initialize(lo, hi)
      raise ArgumentError.new "upper boundary must be greater than the lower one (given: hi = #{hi}, lo = #{lo})" unless hi > lo

      @hi = hi
      @lo = lo

      @number_of_bits = hi - lo
      @range          = Range.new(1, @number_of_bits)
      @free_set       = BitSet.new(@number_of_bits)
    end

### Public Instance Methods

allocate() click to toggle source

Attempts to allocate next available integer. If allocation succeeds, allocated value is returned. Otherwise, nil is returned.

Current implementation of this method is O(n), where n is number of bits in the range available for allocation.

@return [Integer] Allocated integer if allocation succeeded. nil otherwise.

    # File lib/amqp/int_allocator.rb, line 44
    def allocate
      if n = find_unallocated_position
        @free_set.set(n)

        n
      else
        -1
      end
    end

allocated?(reservation) click to toggle source

@return [Boolean] true if provided argument was previously allocated, false otherwise

    # File lib/amqp/int_allocator.rb, line 64
    def allocated?(reservation)
      @free_set.get(reservation)
    end

free(reservation) click to toggle source

Releases previously allocated integer. If integer provided as argument was not previously allocated, this method has no effect.

@return [NilClass] nil

    # File lib/amqp/int_allocator.rb, line 58
    def free(reservation)
      @free_set.unset(reservation)
    end

Also aliased as: release
release(reservation) click to toggle source
Alias for: free
reset() click to toggle source

Releases the whole allocation range

    # File lib/amqp/int_allocator.rb, line 69
    def reset
      @free_set.clear
    end

### Protected Instance Methods

find_unallocated_position() click to toggle source

This implementation is significantly less efficient that what the RabbitMQ Java client has (based on java.lang.Long#nextSetBit and java.lang.Long.numberOfTrailingZeros, and thus binary search over bits). But for channel id generation, this is a good enough implementation.

@private

    # File lib/amqp/int_allocator.rb, line 83
    def find_unallocated_position
      r = nil
      @range.each do |i|
        if !@free_set.get(i)
          r = i
          break;
        end
      end

      r
    end

[Validate]

Generated with the Darkfish Rdoc Generator 2.